
#include "xavr/xavr.h"
#include "xavr/mmc.h"

#include "diskio.h"

static XAVR::MMC<> mmc;

DSTATUS disk_initialize (BYTE drv)
{
  if ( mmc.Init() == XAVR::MMC<>::initOk )
      return 0;
  else
      return STA_NOINIT;
}

DSTATUS disk_status (BYTE drv)
{
  return mmc ? 0 : STA_NOINIT;
}

DRESULT disk_read (BYTE drv, BYTE* buff, DWORD sector, BYTE count)
{
  if ( mmc.Read (sector, buff, count) )
      return RES_OK;
  else
      return RES_ERROR;
}

DRESULT disk_write (BYTE drv, const BYTE* buff, DWORD sector, BYTE count)
{
  if ( mmc.Write (sector, buff, count) )
      return RES_OK;
  else
      return RES_ERROR;
}

DRESULT disk_ioctl (BYTE drv, BYTE ctrl, void *buff)
{
  if ( ctrl == CTRL_SYNC )
    {
      mmc.SelectSS(true);
      if ( mmc.WaitReady() )
          return RES_OK;
    }
  return RES_ERROR;
}

DWORD get_fattime (void)
{
  return 0;
}


